setGeneric("createCOMObject", function(def) standardGeneric("createCOMObject"))

setMethod("createCOMObject", "SCOMEnvironmentClass", function(def) {
             .Call("R_RCOMEnvironmentObject", def, PACKAGE="RDCOMServer")
   })


setMethod("createCOMObject", "SCOMIDispatch", function(def) {
	     funcs <- def@generator()
             obj <- COMSIDispatchObject(funcs)
             .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
   })

setMethod("createCOMObject", "matrix", function(def) {
             obj <- COMSIDispatchObject(matrixCOMHandler(def))
             .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
   })	

# values doesn't really make sense here.
setMethod("createCOMObject", "data.frame", function(def) {
             obj <- COMSIDispatchObject(matrixCOMHandler(def))
             .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
   })	

setMethod("createCOMObject", "SCOMFunctionClass", function(def) {
             obj <- COMSIDispatchObject(def@functions, def@properties)
             .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
   })

setMethod("createCOMObject", "SCOMGenericFunctionClass", function(def) {
             obj <- COMSIDispatchObject(def@functions)
             .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
   })

setMethod("createCOMObject", "ANY", function(def) {
             obj <- genericCOMHandler(def)
             .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
   })



matrixCOMHandler <-
function(m)
{
 f=list(dim = function() dim(m),
 	column = function(j) m[,j, drop = TRUE],
        row = function(i) m[i,, drop = TRUE],
        element = function(i,j) m[i,j],
        nrow = function() nrow(m),
        ncol = function() nrow(m),
        rownames = function() rownames(m),
        colnames = function() colnames(m),
        .properties = character(0)
       )

 if(is.matrix(m))
   f[["values"]] = function() as.vector(m)
  
 f
}	
