

SEngineDispatch = 
function(funs, properties = character(0),   nameManager = COMNameManager()) 
{
  if(length(properties))
    funs[[".properties"]] = properties

  hasProperty =
   function(name) {
     name %in% funs[[".properties"]]
   }

  getProperty = function(name) get(name, envir = environment(funs[[1]]))
  setProperty = function(name, val) assign(name, val, envir = environment(funs[[1]]))

  invoke = 
    function(id, method, args, namedArgs) {
     if(length(namedArgs)) {
       names(args)[1:length(namedArgs)] = names(.ids)[namedArgs]
     }
     args = rev(args)

     name = nameManager(id)

     if(method[2] && !method[1] && !hasProperty(name)) {
       return(COMError("DISP_E_MEMBERNOTFOUND", className = c("COMReturnValue", "COMError")))
     }

     if(hasProperty(name) && any(method[-1])) {
       if(method[2])
         return(getProperty(name))
       else
         return(setProperty(name, args[[1]]))
     } else if(method[1]) {
         # we are dealing with a method name.
       if(name %in% names(funs)) {
         f = funs[[name]]
         return(eval(as.call(c(f, args)), env = globalenv()))
       } else if(exists(name, mode="function")) {
cat("Global function", name,"\n")
         return(do.call(name, args))
       }
     }

         # Looking for an element which corresponds to a function but
         # method[1] is not set so can't call it.
     return(COMError("DISP_E_MEMBERNOTFOUND", className = c("COMReturnValue", "COMError")))
    }

  list(Invoke = invoke, GetNamesOfIDs = nameManager)
}


 setClass("SCOMEngineClass", representation("SCOMFunctionClass"))
 setMethod("createCOMObject", "SCOMEngineClass", 
       function(def) {
         obj = SEngineDispatch(def@functions, def@properties)
	 .Call("R_RCOMSObject", obj, PACKAGE="RDCOMServer")
       })
