#include <iostream>
#include "RCOMFactory.h"
#include <oaidl.h>
#include "converters.h"

#include "SFuncs.h"

#undef ERROR
#include "Rdefines.h"

HMODULE g_hModule;

long gr_cComponents, gr_cServerLocks;


//
// Can DLL unload now?
//
extern "C" {
STDAPI DllCanUnloadNow()
{
	if ((gr_cComponents == 0) && (gr_cServerLocks == 0))
	{
#ifdef RDCOM_VERBOSE
	  cerr << "Can unload DLL" << endl;
#endif
		return S_OK ;
	}
	else
	{
		return S_FALSE ;
	}
}


//
// Get class factory
//

STDAPI DllGetClassObject(const CLSID& clsid,
                         const IID& iid,
                         void** ppv)
{

  SEXP classDef = R_NilValue;
#ifdef RDCOM_VERBOSE
  cerr << "DllGetClassObject" << endl;
#endif
        if(lookupRClassId(clsid, &classDef) == S_FALSE) {
	  cerr << "Unknown iid in DllGetClassObject" << endl;
	  return CLASS_E_CLASSNOTAVAILABLE ;
	}
	// Create class factory.
	RCOMFactory* pFactory = new RCOMFunctionFactory(classDef);  // No AddRef in constructor
	if (pFactory == NULL)
  	    return E_OUTOFMEMORY ;

	// Get requested interface.
	HRESULT hr = pFactory->QueryInterface(iid, ppv) ;
	pFactory->Release();
#ifdef RDCOM_VERBOSE
  cerr << "[end DllGetClassObject] factory = " << *ppv << endl;
#endif
	return hr ;
}



///////////////////////////////////////////////////////////
//
// DLL module information
//

static char *argv[] = {"RDCOMServer"};
extern int Rinit(int argc, char **argv);
BOOL APIENTRY DllMain(HANDLE hModule,
                      DWORD dwReason,
                      void* lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		g_hModule = (HMODULE) hModule ;
		/* Start R session. */
		Rinit(sizeof(argv)/sizeof(argv[0]), argv);
#ifdef RDCOM_VERBOSE
		cerr << "Started R" << endl;
#endif
	}
	return TRUE ;
}

} /* end of extern "C" {...*/
