#include "RCOMObject.h"

extern "C" {
  SEXP R_RCOMEnvironmentObject(SEXP);
  SEXP R_RCOMSObject(SEXP def);
}


SEXP 
R_RCOMEnvironmentObject(SEXP def)
{
  RCOMEnvironmentObject *obj;
  obj = new RCOMEnvironmentObject(def);
  SEXP ans = R_MakeExternalPtr((void *) obj, Rf_install("RCOMEnvironmentObject"), Rf_install("RCOMEnvironmentObject"));
  return(ans);
}


SEXP 
R_RCOMSObject(SEXP def)
{
  RCOMSObject *obj;
  obj = new RCOMSObject(def);
  SEXP ans = R_MakeExternalPtr((void *) obj, Rf_install("RCOMSObject"), Rf_install("RCOMSObject"));
  return(ans);
}



HRESULT
lookupRClassId(const CLSID &clsid, SEXP *def)
{
  SEXP ans, e, tmp;
  int errorOccurred;
  LPOLESTR ostr;
  HRESULT hr;

  hr = StringFromCLSID(clsid, &ostr);
  if(FAILED(hr))
    return(S_FALSE);

  PROTECT(e = allocVector(LANGSXP, 2));
  SETCAR(e, Rf_install("GetCOMClassDef"));
  SETCAR(CDR(e), mkString(FromBstr(ostr)));  
  ans = R_tryEval(e, R_GlobalEnv, &errorOccurred);

  
  hr = (!errorOccurred && ans != R_NilValue) ? S_OK : S_FALSE;
  if(hr == S_OK) {
    R_PreserveObject(ans);
    *def = ans;
  } else {
    cerr << "Couldn't find class definition for " << ostr << endl;
  }

  UNPROTECT(1);
  return(hr);
}
